//
//  viergewinnt.java
//  viergewinnt
//
//  Created by Markus Gierhardt on Sat Oct 04 2003.
//

// import javax.swing.*;
import java.applet.*; // import javax.swing.*;
import java.awt.*;
import java.lang.Math;
import java.util.Random;
import java.awt.event.*;
// import MessageBox.*;
// import SchlauesSpielfeld.*;

// import java.awt.Toolkit; wird gebraucht fr Toolkit.getDefaultToolkit().beep();
// import com.borland.jbcl.layout.*;

public class kreise
    extends Applet
    implements ActionListener, Runnable {

  static int debug = 0; // 1= eingeschaltet
  static int d = 20; // Durchmesser der Spielsteine

  static int maxspieler = 2;
  static int Computer = 2;
  static int maxX = 7; // array-grenzen ndern!
  static int maxY = 6; // muss bereinstimmen mit tspielfeld.java
  static int AnzStrategien = 5;

  SchlauesSpielfeld spielfeld = new SchlauesSpielfeld();
  int[] gewonnen = new int[maxspieler + 1];
  boolean[] verlorenmitstrategie = new boolean[AnzStrategien + 1];
  int anzahlremie = 0;
  private int level = 1;
  private int strategie;
  private Random zufall = new Random();
  private int inCURlevelgewonnen = 0;
  Panel panelbuttons = new Panel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GridLayout gridLayoutbuttons = new GridLayout();
  Button bns[] = new Button[maxX + 1];
  Thread ziehThread;
  boolean[] threadfertig = new boolean[maxX + 1];
  boolean gezogen;
  Thread[] steinthread = new Thread[maxX + 1];

  Panel panelOpt = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  Button neuesspielButton = new Button("Neues Spiel");
  Label labelstand = new Label("Sie haben 0 von 0 Spielen gewonnen");
  Label labelremie = new Label("0 mal unentschieden");
  Label labellevel = new Label("Level " + level);
  Label labelgewinnbislevel = new Label("Ntige Gewinne frs nchste Level: " +
                                        (level - inCURlevelgewonnen));
  Label labelleerzeile = new Label(" ");
  Label labelautor = new Label("Programmiert 11/2003 von Robert Arnold");
  Label labelversion = new Label("Version 2/2007");
  SchlauesSpielfeld[] vorausfeld = new SchlauesSpielfeld[maxX + 1];

  static String linienfarbe = "#800080";
  static String zugmarkierungsfarbe = "#000000";
  static String farbwerte[] = {
      "#ff0000", "#0000ff"};
  static String farbname[] = {
      "Rot", "Blau"};

//l    XYLayout xYLayout1 = new XYLayout();
//l    JLabel jLabel1 = new JLabel();

  public void init() {
    setLayout(gridBagLayout1);
    GridBagConstraints tmp2 = new GridBagConstraints();
    tmp2.gridx = 8;
    tmp2.gridy = 0;
    tmp2.gridwidth = 8;
    tmp2.gridheight = 1;
    tmp2.weightx = 0.0;
    tmp2.weighty = 1.0;
    tmp2.anchor = GridBagConstraints.EAST;
    tmp2.fill = GridBagConstraints.HORIZONTAL;
    tmp2.insets = new Insets(0, 0, 0, 0);
    tmp2.ipadx = 1;
    tmp2.ipady = 1;
    add(panelOpt, tmp2);

    panelOpt.setVisible(true);
    panelOpt.setLayout(gridLayout2);
    gridLayout2.setColumns(1);
    gridLayout2.setVgap(0);
    gridLayout2.setHgap(0);
    gridLayout2.setRows(8);
    panelOpt.add(labellevel);
    panelOpt.add(labelstand);
    panelOpt.add(labelremie);
    panelOpt.add(labelgewinnbislevel);
    panelOpt.add(neuesspielButton);
    neuesspielButton.setActionCommand("ns");
    neuesspielButton.addActionListener(this);
    panelOpt.add(labelleerzeile);
    panelOpt.add(labelautor);
    panelOpt.add(labelversion);

    GridBagConstraints tmp = new GridBagConstraints();
    tmp.gridx = 0;
    tmp.gridy = 0;
    tmp.gridwidth = 2;
    tmp.gridheight = 1;
    tmp.weightx = 1.0;
    tmp.weighty = 1.0;
    tmp.anchor = GridBagConstraints.NORTH;
    tmp.fill = GridBagConstraints.HORIZONTAL;
    tmp.insets = new Insets(0, 0, 0, 0);
    tmp.ipadx = 1;
    tmp.ipady = 1;
    add(panelbuttons, tmp);

    panelbuttons.setVisible(true);
    panelbuttons.setLayout(gridLayoutbuttons);
    gridLayoutbuttons.setColumns(7);
    gridLayoutbuttons.setVgap(10);
    gridLayoutbuttons.setHgap(10);
    gridLayoutbuttons.setRows(1);

    for (int x = 1; x <= maxX; x++) {
      bns[x] = new Button(Integer.toString(x));
      bns[x].addActionListener(this);
      panelbuttons.add(bns[x]); //l , new XYConstraints(x*40-25, 10, 30 , 30));
    }
    //     spielvorbei=false;
    int tief = (level < 3 ? level * 2 : 2 * 3 + (level - 3)); // auch in actionperformed ndern
    verlorenestrategienleeren();
    strategie = nextStrategie();
    spielfeld.neuesspiel(tief, strategie);
    try {
      aufgegnerzeitrechnen();
    }
    catch (SchlauesSpielfeld.AbbruchException e) {}
    ;
  }

  private int nextStrategie() { // per Zufall eine Strategie auswhlen, mit der der Computer im aktuellen Level noch nicht verloren hat
    int strategien = AnzStrategien;
    int i;
    for (i = 0; i <= AnzStrategien - 1; i++) { // Anzahl Strategien ermitteln, mit denen der Computer noch nciht verloren hat
      if (verlorenmitstrategie[i] == true) {
        strategien--;
      }
    }
    if (strategien == 0) { // ab level 5 kann der Computer mit allen Strategien einmal verloren haben -> wieder Zufall bestimmen lassen
    	strategien = AnzStrategien;
    	verlorenestrategienleeren();
    }
    int stratnr = 1 + java.lang.Math.abs(zufall.nextInt()) % (strategien - 1); // Angriffslust = Zufall zwischn 0 und 4

    for (i = 0; i <= AnzStrategien - 1; i++) {
      if (verlorenmitstrategie[i] == false) {
        stratnr--;
      }
      if (stratnr == 0) {
        break;
      }
    }
    return i;
  }

  public void actionPerformed(ActionEvent e) {
    String ac = e.getActionCommand();
    /** todo  mit AudioClip kann man wav dateien abspielen */
    if (ac == "ns") {
      int tief = (level < 3 ? level * 2 : 2 * 3 + (level - 3)); // auch in init ndern
      strategie = nextStrategie();
      spielfeld.neuesspiel(tief, strategie); // 4= totale Offensive 0= totale Defensive
      labellevel.setText("Level " + level);
      labelgewinnbislevel.setText("Ntige Gewinne frs nchste Level: " +
                                  (level - inCURlevelgewonnen));
      buttonsein();
      repaint();
      try {
        aufgegnerzeitrechnen();
      }
      catch (SchlauesSpielfeld.AbbruchException f) {}
      ;
      return;
    }
    ;

    buttonsaus();
    neuesspielButton.disable();
    int x = ac.charAt(0) - 48;
    int sp = spielfeld.spieler;
    int spielvorbei = evtlzieh(x);
    if (spielvorbei == 1) {
      berechnungabbrechen(0); // 0 = alle abbrechen
      return;
    }
    if (spielvorbei == 2) {
      return;
    } // Zugverboten
    berechnungabbrechen(spielfeld.letzterzug); // alle vorausberechnungen abbrechen ausser spielfeld.letzterzug
    ziehThread = new Thread(this, "Zge berechnen");
    ziehThread.start();
  }

  public void buttonsaus() {
    for (int i = 1; i <= maxX; i++) {
      bns[i].disable();
    }
  }

  public void buttonsein() {
    for (int x = 1; x <= maxX; x++) {
      bns[x].enable();
    }
  }

  public void berechnungabbrechen(int ausser) {
    for (int i = 1; i <= maxX; i++) {
      if (i != ausser && vorausfeld[i] != null) {
        vorausfeld[i].berechnungabbrechen();
      }
      ;
    }
    boolean allefertig = false;
    try {
      while (!allefertig) {
        Thread.sleep(100);
        allefertig = true;
        for (int i = 1; i <= maxX; i++) {
          if (steinthread[i] != null && i != ausser) {
            if (steinthread[i].isAlive()) {
            	Thread.sleep(200);
              allefertig = false;
            }
          }
        }
      } // warten bis Vorausberechnung fertig abgebrochen
    }
    catch (InterruptedException ex) {}
  }

  public void verlorenestrategiespeichern() {
    int i;
    verlorenmitstrategie[strategie] = true; // strategie = Angriffslust speichern, mit der der Computer verloren hat
    for (i = 0; i <= AnzStrategien - 1; i++) { // mit allen Strategien schonmal verloren?
      if (verlorenmitstrategie[i] == false) {
        break;
      }
    }
    if (i >= AnzStrategien - 1) {
      verlorenestrategienleeren();
    }
    verlorenmitstrategie[strategie] = true; // zu letzt verwendete Strategie nicht freigeben
  }

  public void verlorenestrategienleeren() {
    for (int i = 0; i <= AnzStrategien - 1; i++) {
      verlorenmitstrategie[i] = false;
    }
  }

  public int evtlzieh(int zug) {
    int sp = spielfeld.spieler;
    int spielvorbei = 0; // 1= vorbei 2= verbotener Zug
    int i;
    try {
      spielfeld.zug(zug);
      if (spielfeld.hatspgewonnen() > 0) {
        gewonnen[sp]++;
        spielvorbei = 1;
        labelstand.setText("Sie haben " + gewonnen[1] + " von " +
                           (int) (gewonnen[1] + gewonnen[2] + anzahlremie) +
                           " Spielen gewonnen");
        new MessageBox("Der Spieler mit der Farbe " +
                       farbname[sp - 1] + " hat gewonnen.");
        if (sp != Computer) { // Mensch hat gewonnen
          inCURlevelgewonnen++;
          labelgewinnbislevel.setText("Ntige Gewinne frs nchste Level: " +
                                      (level - inCURlevelgewonnen));
          verlorenestrategiespeichern();
          if (inCURlevelgewonnen == level) {
            level++;
            inCURlevelgewonnen = 0;
            verlorenestrategienleeren();
          }
          ;
          neuesspielButton.enable();
        }
      }
      else {
        if (spielfeld.hatspgewonnen() == -1) {
          meldeunentschieden();
        } //unentschieden
      }
    }
    catch (tspielfeld.SpalteVollException f) {
      if (f.spielfeldvoll) {
        meldeunentschieden();
      }
      else {
        spielvorbei = 2;
        new MessageBox("Der Zug ist nicht erlaubt.");
        buttonsein();
      }
    }
    repaint();
    return spielvorbei;
  }

  public void meldeunentschieden() {
    anzahlremie++;
    //       spielvorbei = true;
    neuesspielButton.enable();
    labelremie.setText(anzahlremie + " mal unentschieden");
    labelstand.setText("Sie haben " + gewonnen[1] + " von " +
                       (int) (gewonnen[1] + gewonnen[2] + anzahlremie) +
                       " Spielen gewonnen");
    new MessageBox("unentschieden - Spielfeld voll");

  }

  public void run() {
    try {
      Thread.sleep(100);
    } // damit kurze Zeit zwsichen Mensch- und Computer-Zug
    catch (InterruptedException ex) {}
    try {
      if (steinthread[spielfeld.letzterzug] != null) {
        try {
          while (steinthread[spielfeld.letzterzug].isAlive()) {
            Thread.sleep(100);
          }
        }
        catch (InterruptedException e) {}
        ;
        int spielvorbei = evtlzieh(vorausfeld[spielfeld.letzterzug].
                                   zugvorschlag);
        if (spielvorbei != 1) {
          buttonsein();
          aufgegnerzeitrechnen();
        }
        else {
          neuesspielButton.enable();
        }
      }

    }
    catch (SchlauesSpielfeld.AbbruchException e) {}
    ;
    //  System.out.print("t zu ende\n");
  }

  public void aufgegnerzeitrechnen() throws SchlauesSpielfeld.AbbruchException {
    for (int x = 1; x <= maxX; x++) { // <=maxX   ==1
      try {
        vorausfeld[x] = new SchlauesSpielfeld(spielfeld);
        vorausfeld[x].zug(x);
        steinthread[x] = new Thread(vorausfeld[x], Integer.toString(x));
        steinthread[x].start();
      }
      catch (tspielfeld.SpalteVollException e) {}
      ;
    }
  }

  public void paint(Graphics g) {
    int x = 0;
    int y = 0;
    super.paint(g);
    int kh = (int) getBounds().height / (maxY + 1);
    int kb = (int) (panelbuttons.getBounds().width - 1) / (maxX);
    g.setColor(Color.decode(linienfarbe));
    for (x = 1; x <= maxX; x++) { // senkrechte Linien vom Gitternetz zeichnen
      g.drawLine( (x - 1) * (kb), kh * maxY - 5 - ( (maxY - 1) * kh),
                 (x - 1) * (kb), kh * (maxY + 1));
    }
    // fehlende Auenlinien vom Gitternetz zeichnen
    g.drawLine(maxX * kb, kh * maxY - 5 - ( (maxY - 1) * kh), maxX * kb,
               kh * (maxY + 1));
    g.drawLine( (maxX) * (kb), kh * (maxY + 1), 0, kh * (maxY + 1));
    for (y = 1; y <= maxY; y++) {
      g.setColor(Color.decode(linienfarbe)); // Waagerechte Linien vom Gitternetz zeichnen
      g.drawLine(0, kh * maxY - 5 - ( (y - 1) * (kh)), kb * maxX,
                 kh * maxY - 5 - ( (y - 1) * (kh)));
      for (x = 1; x <= maxX; x++) {
        if (spielfeld.daten[x][y] != 0) {
          g.setColor(Color.decode(farbwerte[spielfeld.daten[x][y] - 1]));
          g.fillOval( (x - 1) * (kb), kh * maxY - 5 - ( (y - 1) * (kh)), kb, kh);
          if (x == spielfeld.letzterzug && // letzten Zug markieren
              (spielfeld.daten[x][y + 1] == 0 ||
               spielfeld.daten[x][y + 1] == -1)) {
            g.setColor(Color.decode(zugmarkierungsfarbe));
            g.fillOval( (x - 1) * (kb) + kb / 4,
                       kh * maxY - 5 - ( (y - 1) * (kh)) + kh / 4, kb / 2,
                       kh / 2);
          }
        }
      }
    }

  }
}
/*    g.setColor(Color.blue);
        g.setFont(font);
        g.drawString(message, 40, 80);
        system.print() */
/*
     public int zieh(int tiefenzuschlag ) throws SchlauesSpielfeld.AbbruchException {
      SchlauesSpielfeld feld=new SchlauesSpielfeld(spielfeld);
      spielfeld.berechnungabbrechen=false;
     int b=spielfeld.besterzug(spielfeld.spieler,level*2+4+tiefenzuschlag,feld);
//l      jLabel1.setText("Stellungsbwertung "+Integer.toString(feld.bewertung[2])+
//l                      "\n bester Zug: "+Integer.toString(b));
      return b;
    }
 */
